#include <stdio.h>
#include "cio.h"
#include "task.h"
#include <stdarg.h>
#include <string.h>
#include "rs232.h"

extern "C" void DisableInterrupt(void);
extern int ConsolHandle;
char OS[256];

void BombWait(void);

void RPut(int c)
{
	//this is an emergency output
	//no interrupts, no buffers
	while((*((char *)(STATUS_REG_A)) & 0x04) == 0);
	*((char *)(DATA_REG_A)) = c;
}

void RWrite(char *s)
{
	while(*s)
		RPut(*s++);
}

int function;
long access;
int instruction;
int sr;
long adr;

extern "C" void p_error(int except,void *stack,long d0,long d1,long d2,long d3,
						long d4, long d5, long d6, long d7,long a0, long a1,
						long a2, long a3, long a4, long a5, long a6,...)
{
	DisableInterrupt();
	sprintf(OS,"EXCEPTION:%d\r\n",except);
	RWrite(OS);
	switch(except)
	{
		case 2:
		case 3:
			function = *((int *)stack)++;
			access = *((long *)stack)++;
			instruction = *((int *)stack)++;
			sr = *((int *)stack)++;
			adr = *((long *)stack)++;
			sprintf(OS,"Function:%04x  Instruction %04x\r\n",function,instruction);
			RWrite(OS);
			sprintf(OS,"ACCESS:%08lx   ADDRESS:%08lx\r\n",access,adr);
			RWrite(OS);
			sprintf(OS,"STATUS:%04x\r\n",sr);
			RWrite(OS);
			break;
		default:
			sr = *((int *)stack)++;
			adr = *((long *)stack)++;
			break;
	}
	sprintf(OS,"D0:%08lx    D1:%08lx\r\n",d0,d1);
	RWrite(OS);
	sprintf(OS,"D2:%08lx    D3:%08lx\r\n",d2,d3);
	RWrite(OS);
	sprintf(OS,"D4:%08lx    D5:%08lx\r\n",d4,d5);
	RWrite(OS);
	sprintf(OS,"D6:%08lx    D7:%08lx\r\n",d6,d7);
	RWrite(OS);
	sprintf(OS,"A0:%08lx    A1:%08lx\r\n",a0,a1);
	RWrite(OS);
	sprintf(OS,"A2:%08lx    A3:%08lx\r\n",a2,a3);
	RWrite(OS);
	sprintf(OS,"A4:%08lx    A5:%08lx\r\n",a4,a5);
	RWrite(OS);
	sprintf(OS,"A6:%08lx\r\n",a6);
	RWrite(OS);
	BombWait();
}

void BombWait(void)
{
	int sr = EnterCritical();	//disble interrupts
	while(1)
	{
		//attempt to do everything posible to keep system alive
		volatile int a;
		a = 10000;
		while(a--);
		*((volatile char *)(BIT_RESET_COMMAND)) = 0x10;	//toggle watchdog
		Xio(SET_ERROR,ConsolHandle,(char *)0,(char *)0,0l,1);
		a = 10000;
		while(a--);
		*((volatile char *)(BIT_SET_COMMAND)) = 0x10;	//toggle watchdog
		Xio(SET_ERROR,ConsolHandle,(char *)0,(char *)0,0l,0);
	}

}
