#include "task.h"

#ifndef QUEUE__H
#define QUEUE__H

//--------------------------------------------------------------------
// C++ Classes
//--------------------------------------------------------------------

class EventQueue:public TSemaphore {
	char *Buff;		//buffer where data is stored
	int Head;		//head index
	int Tail;		//tail index
	int nChars;		//number of chars in queue
	int Size;		//size of queue
public:
	EventQueue(int size,char *name);	//constructor function
	~EventQueue();
	int PostMessage(int *d,int c);
	virtual int Post(int v=0);
	virtual int Pend(int t=0);
	int Get(void);
	int Put(int c);
	int QueueStatus(void);	//number of char in queue
	int QueueSpace(void);	//how much space left in queue
	void Kill(void);		//Delete Message from Queue
	void *operator new(size_t size);
	void operator delete(void *);
};

class Wait: public TSemaphore{
	//this is like a semaphore (ECB) but no timeout logic
	//for things where waiting forever is OK
	//these have pretty much zero CPU overhead
	int value;			/*	this could be dangerous	*/
public:
	Wait(int count,char *name);
	~Wait();
	virtual int Pend(int timeout=0);
	virtual int Post(int v=0);
	void *operator new(size_t size);
	void operator delete(void *);
};

#endif
