//***********************************************************
// implementation of string class
//***********************************************************

#include <stdio.h>
#include "strings.h"
#include "task.h"
#include "queue.h"

static Wait *blocker=0;

String *String::Master;		//master link to string pool

String::String()
{
}

String::~String()
{
}

void *String::operator new(size_t size)	//new operator for this class
{
	char *p;

	if(!blocker)	//no blocker has been defined
	{
		blocker = new Wait(1,"NewStringsBlocker");
	}
	blocker->Pend();
	if(!Master)		//nothing in pool, create new object
	{
		p = new char[size + 256];
		((String *)p)->s = p + size;
	}
	else
	{

		p = (char *)Master;
		Master = Master->next;	//unlink object
	}
	blocker->Post();
	return (void *)p;
}

void String::operator delete(void *p)		//delete operator for this class
{
	int sr;

	blocker->Pend();
	((String *)p)->next = Master;
	Master = (String *)p;
	blocker->Post();
}

char *String::Get(void)		//get pointer to character data
{
	return s;
}

