//*********************************************************
//
// Header file for string class manager
//
// the purpose of this class is to aid in preventing
// the fragmentation of heap memory
// this function will allocate a large pool of memory for
// use as strings.  Most of the strings that are used are
// 256 bytes or less, so just allocate a pool of 256 byte
// long strings.
//
//*********************************************************

#ifndef STRINGS__H
#define STRINGS__H


class String{
	char *s;
	String *next;	//used to make a linked list of string objects
	static String *Master;	//head pointer to linked list
public:
	String();
	~String();
	void *operator new(size_t size);	//new operator for this class
	void operator delete(void *p);		//delete operator for this class
	char *Get(void);		//get pointer to character data
};

#endif
