/*
** This is the timer routines
** For Spindle Controller board 2-17-95
*/
#include <stdio.h>
#include "timer.h"
#include "rs232.h"

int volatile ticks;

extern void TimerTicker(void);

extern char ImrShadow;

long volatile time_ms;

void the_timer()
{
	static int flag = 0;
	/*
	** this routine gets called from the interrupt service routine
	*/
	--ticks;	/*	decrement global ticker	*/
	time_ms++;	/*	increment time	*/
	/*
	** toggle the watchdog line
	*/

	if(flag)
	{
		flag = 0;
		*((volatile char *)(BIT_RESET_COMMAND)) = 0x10;
	}
	else
	{
		flag = 1;
		*((volatile char *)(BIT_SET_COMMAND)) = 0x10;
	}
	TimerTicker();
}

void init_timer()
{
	register int dummy;

	*((volatile char *)(COUNTER_UPPER_REG)) = 4;
	*((volatile char *)(COUNTER_LOWER_REG)) = 128; 	/*	10 mSEC timer default	*/
	acr_shad |= 0x70;
	*((volatile char *)(AUX_CONTROL_REG)) = acr_shad;
	ImrShadow |= 0x08;	/*	enable bit for timer and input port change	*/
	*((volatile char *)(INTERRUPT_MASK_REG)) = ImrShadow;	/*	enable timer	*/
	dummy = *((volatile char *)(START_COUNTER));
	dummy = *((volatile char *)(INPUT_PORT_CHANGE_REG));
}

void port_change(void)
{
	//----------------------------------------------------
	// this function is called by the 68681 isr routine
	//----------------------------------------------------

	char in_port_change_reg;

	in_port_change_reg = *((char *)(INPUT_PORT_CHANGE_REG));
}
